# %%
from abc import ABC, abstractmethod


# Abstrakte Basisklasse für fahrbare Entitäten
class Driveable(ABC):
    def __init__(self,name):
        self.name = name

    @abstractmethod
    def __drive(self):
        pass

# Abstrakte Basisklasse für fliegbare Entitäten
class Flyable(ABC):
    def __init__(self,name):
        self.name = name

    @abstractmethod
    def __fly(self):
        pass

# Abstrakte Basisklasse für Roboter, die sowohl fahren als auch fliegen können
class Robot(Driveable, Flyable):
    def __init__(self, name):
        super().__init__(name)
        self.__is_flying = False
        self.__is_driving = False

    def __drive(self):
        if not self.is_flying:
            self.__is_driving = True
            self.__is_flying = False
            print(f"{self.name} fährt.")

    def __fly(self):
        if not self.__is_driving:
            self.__is_flying = True
            self.__is_driving = False
            print(f"{self.name} fliegt.")

    def switch_status(self):
        if self.__is_driving:
            print(f"{self.name} startet.")
            self.__is_flying = True
            self.__is_driving = False    
        elif self.__is_flying:
            print(f"{self.name} landet.")
            self.__is_driving = True     
            self.__is_flying = False    
        else:
            print(f"{self.name} steht still.")
            self.__is_driving = True
            print(f"{self.name} fährt los.")

# Beispielverwendung
if __name__ == "__main__":
    robot = Robot("Robi")
    robot.switch_status()
    robot.switch_status()
    robot.switch_status()
    robot.switch_status()
    robot.switch_status()
# %%
